<html>
<head>
    <title>Grid Starter</title>
    <link rel="stylesheet" type="text/css" href="../lib/extjs/resources/css/ext-all.css" />
    <script type="text/javascript" src="../lib/extjs/adapter/ext/ext-base.js"></script>
    <script type="text/javascript" src="../lib/extjs/ext-all.js"></script>
    <script>
    Ext.onReady(function(){
        Ext.BLANK_IMAGE_URL = 'images/s.gif';
        Ext.QuickTips.init();

        var Movie = Ext.data.Record.create([
            'id',
            'coverthumb',
            'title',
            'director',
            'runtime',
            {name: 'released', type: 'date', dateFormat: 'Y-m-d'},
            'genre',
            'tagline',
            {name: 'price', type: 'float'},
            {name: 'available', type: 'bool'}
        ]);
        var store = new Ext.data.Store({
            data: [
                [1, "84m.jpg", "Office Space",     "Mike Judge",        89,  "1999-02-19", 1, "Work Sucks",                              19.95, true],
                [3, "42m.jpg", "Super Troopers",   "Jay Chandrasekhar", 100, "2002-02-15", 1, "Altered State Police",                    14.95, 1],
                [4, "12m.jpg", "American Beauty",  "Sam Mendes",        122, "1999-10-01", 2, "... Look Closer",                         19.95, true],
                [5, "49m.jpg", "The Big Lebowski", "Joel Coen",         117, "1998-03-06", 1, "The \"Dude\"",                            21.9,  true],
                [6, "94m.jpg", "Fight Club",       "David Fincher",     139, "1999-10-15", 3, "How much can you know about yourself...", 19.95, true]
            ],
            reader: new Ext.data.ArrayReader({
                idInndex: 0
            }, Movie)
        });

        var grid = new Ext.grid.GridPanel({
            renderTo: document.body,
            frame: true,
            title: 'Movie Database',
            height: 200,
            width: 520,
            store: store,
            colModel: new Ext.grid.ColumnModel({
                defaultSortable: false,
                columns: [
                    {header: "Title", dataIndex: 'title'},
                    {header: "Director", dataIndex: 'director'},
                    {header: "Released", dataIndex: 'released', xtype: 'datecolumn'},
                    {header: "Genre", dataIndex: 'genre'},
                    {header: "Tagline", dataIndex: 'tagline'}
                ]
            })
        });
    });
    </script>
</head>
<body>
</body>
</html>